Index: /pjproject/branches/projects/android/pjsip-apps/src/apjsua/.project
===================================================================
--- /pjproject/branches/projects/android/pjsip-apps/src/apjsua/.project	(revision 4285)
+++ /pjproject/branches/projects/android/pjsip-apps/src/apjsua/.project	(revision 4286)
@@ -6,4 +6,10 @@
 	</projects>
 	<buildSpec>
+		<buildCommand>
+			<name>org.eclipse.cdt.managedbuilder.core.genmakebuilder</name>
+			<triggers>clean,full,incremental,</triggers>
+			<arguments>
+			</arguments>
+		</buildCommand>
 		<buildCommand>
 			<name>com.android.ide.eclipse.adt.ResourceManagerBuilder</name>
@@ -26,8 +32,18 @@
 			</arguments>
 		</buildCommand>
+		<buildCommand>
+			<name>org.eclipse.cdt.managedbuilder.core.ScannerConfigBuilder</name>
+			<triggers>full,incremental,</triggers>
+			<arguments>
+			</arguments>
+		</buildCommand>
 	</buildSpec>
 	<natures>
 		<nature>com.android.ide.eclipse.adt.AndroidNature</nature>
 		<nature>org.eclipse.jdt.core.javanature</nature>
+		<nature>org.eclipse.cdt.core.cnature</nature>
+		<nature>org.eclipse.cdt.core.ccnature</nature>
+		<nature>org.eclipse.cdt.managedbuilder.core.managedBuildNature</nature>
+		<nature>org.eclipse.cdt.managedbuilder.core.ScannerConfigNature</nature>
 	</natures>
 </projectDescription>
Index: /pjproject/branches/projects/android/pjsip-apps/src/apjsua/jni/Android.mk
===================================================================
--- /pjproject/branches/projects/android/pjsip-apps/src/apjsua/jni/Android.mk	(revision 4286)
+++ /pjproject/branches/projects/android/pjsip-apps/src/apjsua/jni/Android.mk	(revision 4286)
@@ -0,0 +1,33 @@
+# $Id$
+
+LOCAL_PATH	:= $(call my-dir)
+include $(CLEAR_VARS)
+
+# Get PJ build settings
+include ../../../build.mak
+include $(PJDIR)/build/common.mak
+
+# Path to SWIG
+MY_SWIG		:= swig
+
+# Constants
+MY_JNI_WRAP	:= pjsua_app_wrap.c
+MY_JNI_DIR	:= jni
+MY_MODULE 	:= $(PJDIR)/pjsip-apps/build/output/pjsua-$(TARGET_NAME)/*.o
+
+# Android build settings
+LOCAL_MODULE    := libpjsua_app
+LOCAL_CFLAGS    := -Werror $(APP_CFLAGS)
+LOCAL_LDFLAGS   := $(APP_LDFLAGS)
+LOCAL_LDLIBS    := $(MY_MODULE) $(APP_LDLIBS)
+LOCAL_SRC_FILES := $(MY_JNI_WRAP)
+
+# Invoke SWIG
+$(MY_JNI_DIR)/$(MY_JNI_WRAP):
+	@echo "Invoking SWIG..."
+	$(MY_SWIG) -o $(MY_JNI_DIR)/$(MY_JNI_WRAP) -package org.pjsip.pjsua -outdir src/org/pjsip/pjsua -java $(MY_JNI_DIR)/pjsua_app.i
+
+.PHONY: $(MY_JNI_DIR)/$(MY_JNI_WRAP)
+
+include $(BUILD_SHARED_LIBRARY)
+
Index: /pjproject/branches/projects/android/pjsip-apps/src/apjsua/jni/pjsua_app.i
===================================================================
--- /pjproject/branches/projects/android/pjsip-apps/src/apjsua/jni/pjsua_app.i	(revision 4286)
+++ /pjproject/branches/projects/android/pjsip-apps/src/apjsua/jni/pjsua_app.i	(revision 4286)
@@ -0,0 +1,18 @@
+/* File: pjsua_app.i */
+%module pjsua_app
+
+%{
+int initApp();
+void deinitApp();
+int startPjsua(char *cfgFile);
+void setInput(char *s);
+char * getMessage();
+void finishDisplayMsg();
+%}
+
+int initApp();
+void deinitApp();
+int startPjsua(char *cfgFile);
+void setInput(char *s);
+char * getMessage();
+void finishDisplayMsg();
Index: project/branches/projects/android/pjsip-apps/src/apjsua/src/org/pjsip/pjsua/pjsua_app.java
===================================================================
--- /pjproject/branches/projects/android/pjsip-apps/src/apjsua/src/org/pjsip/pjsua/pjsua_app.java	(revision 4285)
+++ 	(revision )
@@ -1,36 +1,0 @@
-/* ----------------------------------------------------------------------------
- * This file was automatically generated by SWIG (http://www.swig.org).
- * Version 2.0.6
- *
- * Do not make changes to this file unless you know what you are doing--modify
- * the SWIG interface file instead.
- * ----------------------------------------------------------------------------- */
-
-package org.pjsip.pjsua;
-
-public class pjsua_app {
-  public static int initApp() {
-    return pjsua_appJNI.initApp();
-  }
-
-  public static void deinitApp() {
-    pjsua_appJNI.deinitApp();
-  }
-
-  public static int startPjsua(String cfgFile) {
-    return pjsua_appJNI.startPjsua(cfgFile);
-  }
-
-  public static void setInput(String s) {
-    pjsua_appJNI.setInput(s);
-  }
-
-  public static String getMessage() {
-    return pjsua_appJNI.getMessage();
-  }
-
-  public static void finishDisplayMsg() {
-    pjsua_appJNI.finishDisplayMsg();
-  }
-
-}
Index: project/branches/projects/android/pjsip-apps/src/apjsua/src/org/pjsip/pjsua/pjsua_appJNI.java
===================================================================
--- /pjproject/branches/projects/android/pjsip-apps/src/apjsua/src/org/pjsip/pjsua/pjsua_appJNI.java	(revision 4285)
+++ 	(revision )
@@ -1,18 +1,0 @@
-/* ----------------------------------------------------------------------------
- * This file was automatically generated by SWIG (http://www.swig.org).
- * Version 2.0.6
- *
- * Do not make changes to this file unless you know what you are doing--modify
- * the SWIG interface file instead.
- * ----------------------------------------------------------------------------- */
-
-package org.pjsip.pjsua;
-
-public class pjsua_appJNI {
-  public final static native int initApp();
-  public final static native void deinitApp();
-  public final static native int startPjsua(String jarg1);
-  public final static native void setInput(String jarg1);
-  public final static native String getMessage();
-  public final static native void finishDisplayMsg();
-}
Index: /pjproject/branches/projects/android/pjsip-apps/src/pjsua/gui.h
===================================================================
--- /pjproject/branches/projects/android/pjsip-apps/src/pjsua/gui.h	(revision 4285)
+++ /pjproject/branches/projects/android/pjsip-apps/src/pjsua/gui.h	(revision 4286)
@@ -26,5 +26,5 @@
 #endif
 
-#ifdef USE_GUI
+#if USE_GUI
 
 #define printf showMsg